// $Id: brshbeca.h 1282 2006-06-09 09:46:49Z alex $
/* @@tag:xara-cn@@ DO NOT MODIFY THIS LINE
================================XARAHEADERSTART===========================
 
               Xara LX, a vector drawing and manipulation program.
                    Copyright (C) 1993-2006 Xara Group Ltd.
       Copyright on certain contributions may be held in joint with their
              respective authors. See AUTHORS file for details.

LICENSE TO USE AND MODIFY SOFTWARE
----------------------------------

This file is part of Xara LX.

Xara LX is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License version 2 as published
by the Free Software Foundation.

Xara LX and its component source files are distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with Xara LX (see the file GPL in the root directory of the
distribution); if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA  02110-1301 USA


ADDITIONAL RIGHTS
-----------------

Conditional upon your continuing compliance with the GNU General Public
License described above, Xara Group Ltd grants to you certain additional
rights. 

The additional rights are to use, modify, and distribute the software
together with the wxWidgets library, the wxXtra library, and the "CDraw"
library and any other such library that any version of Xara LX relased
by Xara Group Ltd requires in order to compile and execute, including
the static linking of that library to XaraLX. In the case of the
"CDraw" library, you may satisfy obligation under the GNU General Public
License to provide source code by providing a binary copy of the library
concerned and a copy of the license accompanying it.

Nothing in this section restricts any of the rights you have under
the GNU General Public License.


SCOPE OF LICENSE
----------------

This license applies to this program (XaraLX) and its constituent source
files only, and does not necessarily apply to other Xara products which may
in part share the same code base, and are subject to their own licensing
terms.

This license does not apply to files in the wxXtra directory, which
are built into a separate library, and are subject to the wxWindows
license contained within that directory in the file "WXXTRA-LICENSE".

This license does not apply to the binary libraries (if any) within
the "libs" directory, which are subject to a separate license contained
within that directory in the file "LIBS-LICENSE".


ARRANGEMENTS FOR CONTRIBUTION OF MODIFICATIONS
----------------------------------------------

Subject to the terms of the GNU Public License (see above), you are
free to do whatever you like with your modifications. However, you may
(at your option) wish contribute them to Xara's source tree. You can
find details of how to do this at:
  http://www.xaraxtreme.org/developers/

Prior to contributing your modifications, you will need to complete our
contributor agreement. This can be found at:
  http://www.xaraxtreme.org/developers/contribute/

Please note that Xara will not accept modifications which modify any of
the text between the start and end of this header (marked
XARAHEADERSTART and XARAHEADEREND).


MARKS
-----

Xara, Xara LX, Xara X, Xara X/Xtreme, Xara Xtreme, the Xtreme and Xara
designs are registered or unregistered trademarks, design-marks, and/or
service marks of Xara Group Ltd. All rights in these marks are reserved.


      Xara Group Ltd, Gaddesden Place, Hemel Hempstead, HP2 6EX, UK.
                        http://www.xara.com/

=================================XARAHEADEREND============================
 */

// BrushBecomeA class header

#ifndef INC_BRSHBEC
#define INC_BRSHBEC

//#include "ccobject.h" - in camtypes.h [AUTOMATICALLY REMOVED]
//#include "becomea.h" - in camtypes.h [AUTOMATICALLY REMOVED]

class Node;
class CCAttrMap;
class BlendPath;
class BecomeA;
class NodeGroup;
class BlendRef;

/***********************************************************************************************

>	class HandleBrushBecomeA: public CC_CLASS_MEMDUMP

	Author:		Diccon_Yamanaka (Xara Group Ltd) <camelotdev@xara.com>
	Created:	25/2/2000
	Purpose:	This class of object is used to store the paths and attribute maps generated for 
				each individual brush object generated by a brushed ink node.  It can either 
				turn these paths into nodepaths for insertion into the tree of pass them back for 
				whatever salicious reason.

***********************************************************************************************/


class HandleBrushBecomeA : public CC_CLASS_MEMDUMP
{
CC_DECLARE_MEMDUMP(HandleBrushBecomeA);

public:
	HandleBrushBecomeA();
	virtual ~HandleBrushBecomeA();

	BOOL Initialise(BecomeA* pBecomeA, Node* pContextNode, Node* pCreatedBy);
public:
	BOOL Passback(Path* pPath, CCAttrMap* pAttrMap, UINT32 Step);
	BOOL HideContextNode();
	BOOL HideCreatedByNode();
	BOOL FinishPassback();
	void SetNumBlendPaths(UINT32 NumPaths) {m_NumBlendPaths = (INT32)NumPaths;}
	BOOL MakeGroupForThisStep() {return m_NumBlendPaths > 1;}

	virtual BOOL IsSecondary() const {return m_bSecondary;}
	virtual void SetSecondary(BOOL bNewValue = TRUE) {m_bSecondary = bNewValue;}

protected:  //DATA
	BecomeA*   m_pBecomeA;
	Node*	   m_pContextNode;
	Node*	   m_pCreatedByNode;
	NodeGroup* m_pNodeGroup;
	UINT32	   m_NumBlendPaths;
	INT32	   m_LastStep;
	BOOL	   m_bFirst;
	BOOL		m_bSecondary;
};


/***********************************************************************************************

>	class BrushBecomeA: public BecomeA

	Author:		Diccon_Yamanaka (Xara Group Ltd) <camelotdev@xara.com>
	Created:	25/2/2000
	Purpose:	This class is passed to inknodes when we wish to turn them into blendpaths that
				we can use to make brushes.  This is essentially a simplified version of BlendBecomeA

***********************************************************************************************/

class BrushBecomeA : public BecomeA
{
	CC_DECLARE_MEMDUMP(BrushBecomeA)

public:
	BrushBecomeA(	BecomeAReason Reason,
					CCRuntimeClass* pClass, 
					UndoableOperation* pOp, 
					BlendRef* pThisBlendRef 
					);

	// This function should be called when Reason == BECOMEA_PASSBACK 
	virtual BOOL PassBack(NodeRenderableInk* pNewNode,NodeRenderableInk* pCreatedByNode,CCAttrMap* pAttrMap);


protected:
	BlendRef* m_pBlendRef;

};


/***********************************************************************************************

>	class SimpleBecomeA : public BecomeA

	Author:		Diccon_Yamanaka (Xara Group Ltd) <camelotdev@xara.com>
	Created:	25/2/2000
	Purpose:	A simple becomeA object that retrieves paths from nodes and makes them available
				to you, the user without messing around with MakeNodePathFromAttributes or any of
				that rubbish

***********************************************************************************************/

class SimpleBecomeA : public BecomeA
{
	CC_DECLARE_MEMDUMP(SimpleBecomeA)

public:
	SimpleBecomeA(	BecomeAReason Reason,
					CCRuntimeClass* pClass, 
					UndoableOperation* pOp
					);

	// This function should be called when Reason == BECOMEA_PASSBACK 
	virtual BOOL PassBack(NodeRenderableInk* pNewNode,NodeRenderableInk* pCreatedByNode,CCAttrMap* pAttrMap);

	NodePath* GetNodePath();
protected:
	NodePath* m_pNodePath;


};




/***********************************************************************************************

>	class BrushBecomeAGroup : public BecomeA

	Author:		Diccon_Yamanaka (Xara Group Ltd) <camelotdev@xara.com>
	Created:	25/2/2000
	Purpose:	Theres no real facility for extracting the brush objects and passing them back, 
				however this provides some sort of workaround, as it will store all the brush objects
				in a group.

***********************************************************************************************/

class BrushBecomeAGroup : public BecomeA
{
	CC_DECLARE_MEMDUMP(BrushBecomeAGroup)

public:
	BrushBecomeAGroup(	BecomeAReason Reason,
					CCRuntimeClass* pClass, 
					UndoableOperation* pOp
					);
	~BrushBecomeAGroup();

	// This function should be called when Reason == BECOMEA_PASSBACK 
	virtual BOOL PassBack(NodeRenderableInk* pNewNode,NodeRenderableInk* pCreatedByNode,CCAttrMap* pAttrMap);
	
	virtual BOOL IsBrushBecomeAGroup() { return TRUE;}

	NodeGroup* GetNodeGroup();
protected:
	NodeGroup* m_pNodeGroup;


};


#endif	
